import Robot
import World
import System

-- Clear screen
clr :: String
clr =  "\\033[2J"

-- Set cursor position
goto :: Pos -> String
goto (x,y) =  "\\033[" ++ show y ++ ";" ++ show x ++ "H"

-- Color reset 

resetColor::String
resetColor = "\\033[0m"

--Couleurs de fond
backBlack :: String
backBlack = "\\033[40m"

backRed :: String
backRed = "\\033[41m"

backGreen :: String
backGreen = "\\033[42m"

backYellow :: String
backYellow = "\\033[43m"

backBlue :: String
backBlue = "\\033[44m"

backMagenta :: String
backMagenta = "\\033[45m"

backCyan :: String
backCyan = "\\033[46m"

backWhite :: String
backWhite = "\\033[47m"

backReset :: String
backReset = "\\033[49m"


drawBord :: World->String
drawBord world = foldr (++) "" [goto (0,y)++"*"++goto (w+2,y)++"*"|y<-[0..h+2]]++goto (1,0)++['*'|x<-[1..w+2]]++goto (1,h+2)++['*'|x<-[1..w+2]]
    where
      w=(width world)
      h=(height world)

shift::Pos->Pos
shift (x,y) = (x+1,y+1)

displayWallsAndBorder::World->String
displayWallsAndBorder world = backBlack++(foldr (++) "" (map (\(x,y)->(goto (shift (x,y))++" ")) (walls world)))++(drawBord world)

displayStart::World->String
displayStart world = backBlue++(goto (shift (start world)))++" "

displayGoals::World->String
displayGoals world = backRed++(foldr (++) "" (map (\(x,y)->(goto (shift (x,y))++" ")) (goals world)))

displayWorld world = system ("echo -e "++"'"++clr++(displayStart world)++(displayGoals world)++(displayWallsAndBorder world)++resetColor++"\n'")
    
drawRobot pos world
    |pos == (start world) = system ("echo -e "++"'"++backBlue++(goto (shift pos))++"#"++resetColor++"\n'")
    |(elem pos (goals world)) = system ("echo -e "++"'"++backRed++(goto (shift pos))++"#"++resetColor++"\n'")
    |otherwise = system ("echo -e "++"'"++(goto (shift pos))++"#\n'")


animate world commande = animate' world (start world) commande
    where animate' world pos [] = do 
            displayWorld world
            drawRobot pos world
            system ("echo -e '"++(goto (shift ((width world),(height world))))++"'")
            putStrLn ("\nAnimation is done")
          animate' world pos (s:ss) = do 
            displayWorld world
            drawRobot pos world
            system ("echo -e '"++(goto (shift ((width world),(height world))))++"'")
            system ("sleep 1")
            animate' world (update pos s) ss 


main = do
  world <- makeWorldFromFile "monde.txt"
  displayWorld world
  let sol=(findTraject world)
  putStr ("Solution = "++sol++"\n")
  system ("sleep 3")
  animate world sol
 
