module World where
import System
import Char

type Pos = (Int,Int)
data World = World{width::Int, height::Int, start::Pos, goals::[Pos], walls::[Pos]}

worldTest::World
worldTest=World{width=9,height=9,start=(1,1),goals=[(2,9)],walls=[(x,2)|x<-[1..7]]++[(x,6)|x<-[4..9]]++[(x,8)|x<-[3..9]]++[(7,y)|y<-[3..4]]++[(4,4)]++[(2,y)|y<-[4,5,7,8]]}

op::(Int,Int,Pos,[Pos],[Pos],Pos)->Char->(Int,Int,Pos,[Pos],[Pos],Pos)
op (w,h,s,g,wa,p@(x,y)) '#' = (w,h,s,g,(p:wa),(x+1,y))
op (w,h,s,g,wa,p@(x,y)) 'S' = (w,h,p,g,wa,(x+1,y))
op (w,h,s,g,wa,p@(x,y)) 'G' = (w,h,s,(p:g),wa,(x+1,y))
op (w,h,s,g,wa,(x,y)) '\n' = ((max w x),h+1,s,g,wa,(1,y+1))
op (w,h,s,g,wa,(x,y)) _ = (w,h,s,g,wa,(x+1,y))


makeWorldFromStr::String->World
makeWorldFromStr str=World{width=w,height=h,start=s,goals=g,walls=wa}
    where (w,h,s,g,wa,p)=foldl (op) (0,0,(0,0),[],[],(1,1)) str


makeWorldFromFile filename = do
  file<-readFile(filename)
  return (makeWorldFromStr file)